	  TITLE     "Data and constant allocations, Margaret Morrison, KV7D"

;	  Copyright, (C) Margaret S. Morrison, 1982,1983

;	  Permission is granted for use so long as this notice of
;	  authorship is retained in the source code.

; Macro definitions

COPYRIGHT MACRO
	  ASC	    "COPYRIGHT (C), DAVID G. HENDERSON, MARGARET S. MORRISON, HAROLD E. PRICE, 1982,1983"
	  MEND

SEI	  MACRO				;disable interrupt
	  ORCC	    #10H
	  MEND

CLI	  MACRO				;enable interrupt
	  ANDCC     #0EFH
	  MEND

SEE	  MACRO				;set entire flag
	  ORCC	    #80H
	  MEND

CLE	  MACRO				;clear entire flag
	  ANDCC     #7FH
	  MEND

CLC	  MACRO				;clear carry bit
	  ANDCC     #0FEH
	  MEND

INC16	  MACRO     &ADDR
	  INC	    &ADDR+1
	  BNE	    I_&&&&
	  INC	    &ADDR
I_&&&&
	  MEND

CLR16	  MACRO     &ADDR
	  CLR	    &ADDR
	  CLR	    &ADDR+1
	  MEND

FL1	  MACRO     &LEN
	  LDB	    #&LEN
	  LBSR	    SAVFLG
	  .IF	    &LEN .EQ. 8 FL1a
	  LDB	    #(8-&LEN)
S_&&&&	  LSLA
	  DECB
	  BNE	    S_&&&&
FL1a	  .NOP
	  MEND

SveFL	  MACRO
Fcount	  .SET	    0
FLa	  .NOP
	  .IF	    Fcount .EQ. FLGBYT FLb
	  FL1	    8
	  STA	    >(NOVFLG+Fcount)
Fcount	  .SET	    Fcount+1
	  .GOTO     FLa
FLb	  .NOP
	  .IF	    FLGEXT .EQ. 0 FLc
	  FL1	    FLGEXT
	  STA	    >(NOVFLG+Fcount)
FLc	  .NOP
	  MEND

FL2	  MACRO     &LEN
	  LDB	    #&LEN
	  BSR	    DECFLG
	  MEND

GetFL	  MACRO
Fcount	  .SET	    0
FLd	  .NOP
	  .IF	    Fcount .EQ. FLGBYT FLe
	  LDA	    >(NOVFLG+Fcount)	 ;get flag byte
	  FL2	    8
Fcount	  .SET	    Fcount+1
	  .GOTO     FLd
FLe	  .NOP
	  .IF	    FLGEXT .EQ. 0 FLf
	  LDA	    >(NOVFLG+Fcount)
	  FL2	    FLGEXT
FLf	  .NOP
	  MEND

GetNov	  MACRO     &LEN
	  LDA	    VIAA		;clear high address bit
	  ANDA	    #.NT.ADR6
	  STA	    VIAA
Ncount	  .SET	    &LEN
	  .IF	    Ncount .LE. 32 GETa
	  LDB	    #32
	  LBSR	    GETTER
	  LDA	    VIAA		;set high address bit
	  ORA	    #ADR6
	  STA	    VIAA
Ncount	  .SET	    Ncount-32
GETa	  .NOP
	  LDB	    #Ncount
	  LBSR	    GETTER
	  MEND

PutNov	  MACRO     &LEN
	  LDA	    VIAA		;clear high address bit
	  ANDA	    #.NT.ADR6
	  STA	    VIAA
Ncount	  .SET	    &LEN
	  .IF	    Ncount .LE. 32 PUTa
	  LDA	    #32
	  LBSR	    PUTTER
	  LDA	    VIAA		;set high address bit
	  ORA	    #ADR6
	  STA	    VIAA
Ncount	  .SET	    Ncount-32
PUTa	  .NOP
	  LDA	    #Ncount
	  LBSR	    PUTTER
	  MEND

RING	  MACRO     &BOT,&TOP
	  CMPX	    &TOP
	  BLE	    R_&&&&
	  LDX	    &BOT
R_&&&&	  RTS
	  MEND

BIT	  MACRO     &ON,&OFF
	  .IF	    &ON .EQ. 0 BITa
	  ORB	    #(&ON)
BITa	  .NOP
	  .IF	    &OFF .EQ. 0 BITb
	  ANDB	    #(.NT.(&OFF)).AN.0FFH
BITb	  .NOP
	  STB	    PIB
	  MEND

; Constants

PAGE	  EQU	    01H
IOPAGE	  EQU	    20H
HDPAGE	  EQU	    28H

BS	  EQU	    8H			;C-H <backspace>
LF	  EQU	    0AH			;C-J <linefeed>
CR	  EQU	    0DH			;C-M <carriage return>
ESC	  EQU	    1BH			;<escape>
BLANK	  EQU	    20H			:<blank>
MONPR	  EQU	    ":"			;:
POINT	  EQU	    21H			;!
COLON	  EQU	    3AH			;:
POUND	  EQU	    23H			;#
ATSIGN	  EQU	    100Q		;@
QUIT	  EQU	    121Q		;Q
TXFER	  EQU	    124Q		;T
EQUAL	  EQU	    3DH			;=
CALL	  EQU	    ">"			;>
LST	  EQU	    "L"			;L
KLINE	  EQU	    "\"			;\

TRY_NM	  EQU	    8			;# tries to init 6551
TEST	  EQU	    0AA55H		;special bit pattern

; Bits for prom programmer

CE_	  EQU	    01H
OE_	  EQU	    02H
CLK	  EQU	    04H
ASEL	  EQU	    08H
VPP	  EQU	    10H
VCC	  EQU	    20H
PGM_	  EQU	    40H
VHI	  EQU	    80H

;Bits for SETINT

TTI	  EQU	    1
TTO	  EQU	    2
TIM	  EQU	    4
PAK	  EQU	    8

; Bits for ERR_FL

NOHDLC	  EQU	    1H
NOPIA	  EQU	    2H
NOVIA	  EQU	    4H
NOSIA	  EQU	    8H

; Bits for Port A output

DCD	  EQU	    80H			;carrier detect
ACT	  EQU	    40H			;stuff in buffer
CMD	  EQU	    20H			;command mode

; Bits for SCMND (6551)

DTR	  EQU	    1H			;DTR_ .or. <all other bits>

REN_	  EQU	    2H			;receive interrupts enabled
TRX	  EQU	    4H			;transmit & receive interrupts
REC	  EQU	    8H			;receive interrupts only

RTS	  EQU	    3H			;RTS_ .and. <other bits>

; Use DTR_ to signal hardware stop & keep receiving

STACK_	  EQU	    1800H

; Masks
			      ;6551
PYERR	  EQU	    01H			;parity error
FRERR	  EQU	    02H			;framing error
OVERR	  EQU	    04H			;overflow error
RDF	  EQU	    08H			;receive data full
TDE	  EQU	    10H			;transmit data empty
BSY	  EQU	    20H			;DCE flag

LOBAUD	  EQU	    0B3H		;110 baud
HIBAUD	  EQU	    76H			;300 baud

			      ;1933
MISCIN	  EQU	    10H			;MISCIN in SR
RCVR	  EQU	    7FH			;receiver on

TXFCS	  EQU	    0FH			;send FCS
TXFLAG	  EQU	    1FH			;send flags
TXABT	  EQU	    2FH			;send ABORT
TXDATA	  EQU	    3FH			;send data

TXMOUT	  EQU	    7FH			;transmit misc. out only

CR3DAT	  EQU	    0FFH		;residual bit count
CR2DAT	  EQU	    0DFH		;HDLC: 8-bit, ext. addr
CR1DAT	  EQU	    RCVR		;HDLC: 8-bit, rec. off, xmit off
HOPER	  EQU	    0CEH		;clear master reset for HDLC
HRESET	  EQU	    0CCH		;master reset for HDLC

			      ;VIA
ADR0_5	  EQU	    3FH			;address bit mask in VIA B

SWIT_1	  EQU	    01H			;switch address in VIA A
ADR6	  EQU	    02H			;high address bit in VIA A
NOV_WE	  EQU	    04H			;write enable in VIA A
STORE	  EQU	    08H			;store enable VIA A
DAT0_3	  EQU	    0F0H		;data bit mask in VIA A

BDAT	  EQU	    ADR0_5		;DDRB direction pattern (1=output)
ADAT	  EQU	    (ADR6+NOV_WE+STORE) ;DDRA direction pattern (0=input)
T2MASK	  EQU	    20H			;see if timer 2 out
T12MOD	  EQU	    0C0H		;timer 1 = baud rate generator
CALMOD	  EQU	    20H			;timer 1 1-shot, timer 2 interval
VINTDS	  EQU	    7FH			;disable VIA interrupts
T2ENAB	  EQU	    0A0H		;enable timer 2 interrupts
CB2	  EQU	    20H

T2DAT	  EQU	    0F023H		;timer 2 data for 10 ms
T2DATA	  EQU	    0F0H		;timer 2 data for 10 ms
T2DATB	  EQU	    23H
T2DATX	  EQU	    0F047H		;timer 2 data for 10 ms
T2DATAX   EQU	    0F0H		;timer 2 data for 10 ms
T2DATBX   EQU	    47H

T_1MS	  EQU	    8A03H		;data for 1 ms
T_1MSL	  EQU	    8AH
T_1MSH	  EQU	    3H
T_1MSX	  EQU	    0407H		;data for 1 ms
T_1MSLX   EQU	    04H
T_1MSHX   EQU	    7H

T_4MS	  EQU	    600EH		;data for 4 ms
T_4MSL	  EQU	    60H
T_4MSH	  EQU	    0EH
T_4MSX	  EQU	    0B01CH		;data for 4 ms
T_4MSLX   EQU	    0B0H
T_4MSHX   EQU	    1CH

IDTIME	  EQU	    23AH		;9-1/2 minutes in 1 s sections
DATA12	  EQU	    0FA15H		;1536 counts + 1000H - instruction times
DATA17	  EQU	    3614H		;1084 counts
DATA22	  EQU	    4013H		;838 counts

			      ;PIA
SETDDR	  EQU	    0H			;set data direction registers
SETDAT	  EQU	    4H			;configure as data
PIAOUT	  EQU	    0FFH		;data for outputs
PIAIN	  EQU	    0H			;data for inputs
HSKDAT	  EQU	    2FH			;pulse handshake, interrupt on rising edge
HSKDIS	  EQU	    2EH			;disable interrupt only

	  TITLE     "Data allocations -- TNC LLR, Margaret Morrison"
; Buffers

	  ORG	    0H

ACY
BECTXT	  RMB	    128
IDTXT	  RMB	    128

; Pointers, counters, and flags

			      ;Terminal buffer
TER_BF	  RMB	    2			;bottom byte
TER_US	  RMB	    2			;"user"
TER_IN	  RMB	    2			;interrupt
TER_TP	  RMB	    2			;top

			      ;Echo buffer
ECO_BF	  RMB	    2
ECO_OU	  RMB	    2
ECO_US	  RMB	    2
ECO_TP	  RMB	    2

			      ;Input buffer
INLIST
TTI_BF	  RMB	    2			;bottom byte
TTI_US	  RMB	    2
TTI_PK	  RMB	    2			;byte after packet end
TTI_CR	  RMB	    2			;byte after <cr> or <lf>
TTI_IN	  RMB	    2			;interrupt pointer
TTI_TP	  RMB	    2			;top byte

TTI_LN	  RMB	    2			;input buffer
TTI_CT	  RMB	    2			;count for C-S
TTI_NM	  RMB	    2			;count for C-Q
INLEN	  EQU	    ($-INLIST)
			      ;Flags
OUTLST
CTS_FL	  RMB	    1			; 1 = received C-S
					;-1 = auto-flow stop
PKT_CT	  RMB	    1			;packet length counter
DFLNM	  EQU	    ($-OUTLST)
			      ;Output buffer
TTO_BF	  RMB	    2			;bottom byte
TTO_OU	  RMB	    2			;interrupt pointer
TTO_US	  RMB	    2			;"user" pointer
TTO_TP	  RMB	    2			;top byte
OUTLEN	  EQU	    ($-OUTLST)

; packet pointer area
PKI_BF	  RMB	    2			;bottom of buffer
PKI_US	  RMB	    2			;removal pointer
PKI_IN	  RMB	    2			;insertion pointer
PKI_BG	  RMB	    2			;beginning of next unread packet
PKI_TP	  RMB	    2			;top of buffer

PKO_BF	  RMB	    2			;bottom of buffer
PKO_OU	  RMB	    2			;removal pointer
PKO_US	  RMB	    2			;insertion pointer
PKO_TP	  RMB	    2			;top of buffer

TMP_PK	  RMB	    2			;transparent temp fence

			      ;Flags
FLAGS
TYP_FL	  RMB	    1			;typing in progress
TRN_FL	  RMB	    1			;transparent mode status
PAC_FL	  RMB	    1			;fence status flag
CMD_CT	  RMB	    1			;escape count
OPQ_FL	  RMB	    1			;leftover non-transparent packets
BSY_FL	  RMB	    1			;GETCHR in use
CTO_FL	  RMB	    1			;output flushed
XOF_FL	  RMB	    1			;sent C-S
					; -1 => sent hardware flow
XON_RQ	  RMB	    1			;request C-Q
XOF_RQ	  RMB	    1			;request C-S

TOK_FL	  RMB	    1	      ;-1 no transmission
			      ; 0 transmit anything
			      ; 1 packet 1st try or digipeat ok
			      ; 2 digipeat ok
DLY_FL	  RMB	    1			;delay by repeater keyup time
PKT_ST	  RMB	    1			;packet output status
PKO_CT	  RMB	    2			;output counter
PKW_FL	  RMB	    1			;packet waiting for clear freq.
IDG_FL	  RMB	    1			;CW id in progress
KEY_FL	  RMB	    1	      ;-1 ID < 10 min ago, no tx since
			      ; 0 no ID, no tx
			      ; 1 tx since last ID

PKI_CT	  RMB	    2			;input counter
PKI_FU	  RMB	    1			;input buffer full
PKI_FL	  RMB	    1			;incoming packet ready
RER_FL	  RMB	    1			;incoming packet error

	  ; monitor flag: 2 => monitor from command mode
	  ;		  1 => monitor from data mode
	  ;		  0 => data mode
	  ;		 -1 => command mode
DBG_FL	  RMB	    1			;monitor running
ALT_FL	  RMB	    1			;monitor alter mode
RAN_TM	  RMB	    2			;random wait time
HNG_TM	  RMB	    1			;hang before dropping tx
BRK_FL	  RMB	    1			;break being typed in
DIA_FL	  RMB	    1			;parallel port diagnostics?
ABD_FL	  RMB	    1			;autobauder in use
STATUS	  RMB	    2			;tx/rx status words
CHG_FL	  RMB	    1			;mode-change flag

			      ;Clocks
ID_CLK	  RMB	    2			;CWid clock
CLOCK
CS_CLK	  RMB	    2			;CSMA clock
CL_CLK	  RMB	    2			;basic clock
TN_CLK	  RMB	    2			;transparent-mode clock
ST_CLK	  RMB	    2			;random time clock
NCLOK	  EQU	    ($-CLOCK)/2
NFLAG	  EQU	    ($-FLAGS)

			      ;Counters
ERR_FL	  RMB	    1			;no HDLC
SCR_CT	  RMB	    1			;screen width counter
FLG_NM	  RMB	    1			;number of end flags

			      ;Temporary storage
ADDRES	  RMB	    2
BYTE	  RMB	    1
TCOUNT	  RMB	    2
ELM_CT	  RMB	    1
IDS_CT	  RMB	    1
MRKTON	  RMB	    1			;1=> now sending mark

			      ;Interrupt dispatch table
VECTAB
TTI_IV	  RMB	    2			;RDF true
TTO_IV	  RMB	    2			;TDE true
CLK_IV	  RMB	    2			;clock interrupt
PKT_IV	  RMB	    2			;pkt interrupt
PRL_IV	  RMB	    2
			      ;Test word
TST_WD	  RMB	    2
			      ;Linear buffers
MON_BF	  RMB	    2			;monitor mode
CMD_BF	  RMB	    2
VECLEN	  EQU	    ($-VECTAB)

; TTBAUD CODE:	(high 4 bits)

; Bit 7   Stop bits	      0 == 1 stop bit
;			      1 == 2 stop bits
; Bit 6-5 Output parity       0 == odd
;			      1 == even
;			      2 == mark
;			      3 == space
; Bit 4   Word length	      0 == 8 bits
;			      1 == 7 bits

	  GLOBAL    TTBAUD
RONTOF	  RMB	    1
TTBAUD	  RMB	    1			;6551 control register
RFBAUD	  RMB	    2

C_DLLR	  RMB	    1			;escape-echo character
SAVE_C	  RMB	    1			;8-bit command character
INTRPT	  RMB	    1			;interrupt mask
EOL_ST	  RMB	    1			;<cr> <nulls> <lf> <nulls>
EOL_CT	  RMB	    1			;null count
; slush goes here

	  TITLE     "NOVRAM data -- TNC LLR, Margaret Morrison"
; Data from NOVRAM

ACX
NOV_FL

BRD_FL	  RMB	    1			;Bill Reed mode
NLC_FL	  RMB	    1			;null after <cr>
NLL_FL	  RMB	    1			;null after <lf>
ESC_FL	  RMB	    1			;echo <escape> / echo $
UCS_FL	  RMB	    1			;lower case (on) / no lc
BSP_FL	  RMB	    1			;backspace / backslash
ECO_FL	  RMB	    1			;echo / no echo
ALF_FL	  RMB	    1			;auto linefeed / no auto lf

STP_FL	  RMB	    1			;XON/XOF / hardware
FLO_FL	  RMB	    1			;typeing flow control
DEL_FL	  RMB	    1			;delete / backspace
ADP_FL	  RMB	    1			;AX.25 digipeat
VDP_FL	  RMB	    1			;Vancouver digipeat
CON_FL	  RMB	    1			;connect OK
TXM_FL	  RMB	    1			;OK to transmit
A25_FL	  RMB	    1			;originate AX.25 / Vancouver

TMO_FL	  RMB	    1			;timeout mode
MOD_FL	  RMB	    1			;connect mode converse / transparent
REP_FL	  RMB	    1			;please repeat me
CRT_FL	  RMB	    1			;cr at end of packet
CPT_FL	  RMB	    1			;use PAC_TM in converse
TXF_FL	  RMB	    1			;use XFLOW in transparent
AID_FL	  RMB	    1			;auto ID on
BEV_FL	  RMB	    1			;beacon every / after

FDX_FL	  RMB	    1			;full duplex mode
MFL_FL	  RMB	    5			;monitor mode flags

FLGLEN	  EQU	    ($-NOV_FL)
FLGBYT	  EQU	    (FLGLEN/8)
FLGEXT	  EQU	    (FLGLEN-FLGBYT*8)

FLGcnt	  SET	    FLGBYT
	  IF	    FLGEXT.NE.0
FLGcnt	  SET	    FLGcnt+1
	  ENDIF

NOVLST
SCR_WD	  RMB	    2			;maximum screen width
PKT_LN	  RMB	    2			;maximum packet length

CHRLST
C_DELE	  RMB	    1			;delete character

BYTLST
C_CTLX	  RMB	    1			;cancel line
C_CTLY	  RMB	    1			;cancel packet
C_CTLS	  RMB	    1			;stop
C_CTLQ	  RMB	    1			;start
MONNUM	  EQU	    ($-CHRLST)		;characters that work in debugger

C_CTLV	  RMB	    1			;quote
C_RDSP	  RMB	    1			;redisplay line
C_CTLP	  RMB	    1			;send packet
C_CTLC	  RMB	    1			;command
CHRNUM	  EQU	    ($-CHRLST)

C_CTLE	  RMB	    1			;debug
C_XOF	  RMB	    1			;xoff
C_XON	  RMB	    1			;xon
VANCID	  RMB	    1			;fixed ID

CALSIN	  RMB	    6			;call sign
BYTNUM	  EQU	    ($-BYTLST)

INDBYT
CALEXT	  RMB	    2			;call sign extension
RFCODE	  RMB	    2			;HDLC baud rate
NUL_NM	  RMB	    2			;fill number
RET_NM	  RMB	    2			;retry number
ACK_TM	  RMB	    2			;acknowledge delay
INF_NM	  RMB	    2			;max number in flight

EXPBYT	  RMB	    12			;hi level integers
;	  TXM_TM
;	  RPT_TM
;	  SQL_TM
;	  PAC_TM
;	  CMD_TM
;	  DWT_TM

HAFNUM	  EQU	    ($-INDBYT)/4

BEC_TM	  RMB	    2			;beacon time
ABAUD	  RMB	    2
ABIT	  RMB	    2
AWLEN	  RMB	    2
PARITY	  RMB	    2

; End of NOVRAM parameters

AIRP	  RMB	    2			;"user" pointer
LIN_FL	  RMB	    1			;line ready - <cr> typed

HOFC	  RMB	    2			;output available size
AOFC	  RMB	    2			;output free count
BECLEN	  RMB	    2			;beacon text length

HIZERO
IDLEN	  RMB	    2			;id text length

HI_CLK	  RMB	    2			;hi level clock
DRP_FL	  RMB	    1			;DCD has dropped
DCD_FL	  RMB	    1			;DCD status
DIG_FL	  RMB	    1			;digipeated packet
RTY_FL	  RMB	    1			;retry packet

HITSZ	  RMB	    2			;input packet length

COM_FL	  RMB	    1			;command/qso mode
QSO_FL	  RMB	    1			;converse/transparent
ACT_FL	  RMB	    1			;HDLC not empty
T1_TMR	  RMB	    4			;protocol timer
T2_TMR	  RMB	    4			;beacon timer
UCONCNT   RMB	    2			;unconnected list length

HIZNUM	  EQU	    ($-HIZERO)

; copy of NOVRAM
NOVDAT
TTCODE	  RMB	    1			;terminal parameters
NOVFLG	  RMB	    FLGcnt		;flag bytes
NOVBYT	  RMB	    BYTNUM+2
HAFBYT	  RMB	    HAFNUM
Beacon	  RMB	    1
NOVNUM	  EQU	    ($-NOVDAT)

; scratch pointer area
SCILST
SCI_BF	  RMB	    2			;bottom byte
US	  EQU	    ($-SCILST)
SCI_US	  RMB	    2
PK	  EQU	    ($-SCILST)
SCI_PK	  RMB	    2			;byte after packet end
SCI_CR	  RMB	    2			;byte after <cr> or <lf>
IN	  EQU	    ($-SCILST)
SCI_IN	  RMB	    2			;interrupt pointer
SCI_TP	  RMB	    2			;top byte

LN	  EQU	    ($-SCILST)
SCI_LN	  RMB	    2			;input buffer
CT	  EQU	    ($-SCILST)
SCI_CT	  RMB	    2			;count for C-S
SCI_NM	  RMB	    2			;count for C-Q

DOUBYT
TXM_TM	  RMB	    2	      ;4 4 1-16    keyup delay
RPT_TM	  RMB	    2	      ;0 12 0-15   repeater keyup delay
SQL_TM	  RMB	    2	      ;0 48 0-15   squelch delay
PAC_TM	  RMB	    2	      ;1 100 0-15  packet timeout
CMD_TM	  RMB	    2	      ;1 100 0-15  command mode timeout
DWT_TM	  RMB	    2	      ;0 4 0-15    min time to wait
DUBNUM	  EQU	    ($-DOUBYT)/2

DEF_FL	  RMB	    1			;default NOVRAM flag
PRO_CT	  RMB	    1			;count of prompt string
PRO_ST	  RMB	    2			;address of prompt string

; monitor pointer area
MNLIST	  RMB	    (INLEN+OUTLEN)

; command pointer area
CMLIST
CMI_BF	  RMB	    2			;bottom byte
CMI_US	  RMB	    2
CMI_PK	  RMB	    2			;byte after packet end
CMI_CR	  RMB	    2			;byte after <cr> or <lf>
CMI_IN	  RMB	    2			;interrupt pointer
CMI_TP	  RMB	    2			;top byte

CMI_LN	  RMB	    2			;input buffer
CMI_CT	  RMB	    2			;count for C-S
CMI_NM	  RMB	    2			;count for C-Q
CLN_FL	  RMB	    1

; Ram check data

RAMTOP	  RMB	    2			;use this place to store RAM count
HIBOT	  RMB	    2			;high RAM information
HITOP	  RMB	    2

; Data for CW ID

USTK4
BIT_CD	  RMB	    1			;code
BIT_CT	  RMB	    1			;roll count
CAL_IX	  RMB	    2			;call index
TAB_IX	  RMB	    2			;CW table index
USTK5

	  RMB	    2

; data for prom programmer

BYTCNT	  RMB	    2	      ;D - number of bytes
DESTIN	  RMB	    2	      ;X - ROM address
SOURCE	  RMB	    2	      ;Y - RAM address
BASADR	  RMB	    2	      ; base address

TTISAV	  RMB	    2
TIMSAV	  RMB	    2

BOTHOF	  RMB	    1
BUS_FL	  RMB	    1			;6551 dcd line (printer control)
TON_FL	  RMB	    1			;checked & set tone at beg of ID

; Monitor data

MONLEN	  EQU	    150
MON	  RMB	    MONLEN

TERBUF	  EQU	    10H			;pseudoterminal buffer
ECOBUF	  EQU	    20H			;echo output buffer
TINBUF	  EQU	    300H		;terminal input buffer
TOUBUF	  EQU	    300H		;terminal output buffer
MINBUF	  EQU	    20H			;monitor input buffer
MOUBUF	  EQU	    20H			;monitor output buffer
CINBUF	  EQU	    90H			;command input buffer
PKIBUF	  EQU	    300H		;incoming packets
PKOBUF	  EQU	    300H		;outgoint packets

BUFTOP	  RMB	    TERBUF
	  RMB	    ECOBUF
	  RMB	    TINBUF
	  RMB	    TOUBUF
	  RMB	    PKIBUF
	  RMB	    PKOBUF
	  RMB	    MINBUF
	  RMB	    MOUBUF
	  RMB	    CINBUF
MONBUF	  RMB	    20H			;monitor line buffer
COMBUF	  RMB	    20H			;"command" line buffer
BUFBOT

	  TITLE     "Hardware addresses -- TNC LLR, Margaret Morrison"

	  ORG	    2000H
Htop
	  RMB	    10H			;move to 2010
A6551
TDR					;transmit data register (W)
RDR	  RMB	    1			;receive data register (R)
SSTAT					;status (R)
SRESET	  RMB	    1			;reset (W)
SCMND	  RMB	    1			;command
SCNTRL	  RMB	    1			;control
E6551	  EQU	    ($-Htop)

	  RMB	    (20H-E6551)		;move to 2020
A6520
PIA					;peripheral A
PDDRA	  RMB	    1			;data-direction A
CRA	  RMB	    1			;control A
PIB					;peripheral B
PDDRB	  RMB	    1			;data-direction B
CRB	  RMB	    1			;control B
E6520	  EQU	    ($-Htop)

	  RMB	    (40H-E6520)		;move to 2040
A6522
VIAB	  RMB	    1			;output registers
VIAA	  RMB	    1			;(handshake)
DDRB	  RMB	    1			;data direction registers
DDRA	  RMB	    1
TIM1	  RMB	    2			;timer 1 write latch/read counter
T1LAT	  RMB	    2			;timer 1 latch
TIM2	  RMB	    2			;timer 2
SHIFTR	  RMB	    1			;shift register
AUXCR	  RMB	    1			;auxilliary control register
PERCR	  RMB	    1			;peripheral control register
IFR	  RMB	    1			;interrupt flag register
IER	  RMB	    1			;interrupt enable register
PORTA	  RMB	    1			;output register A (no handshake)
E6522	  EQU	    ($-Htop)

	  RMB	    (802H-E6522)	;move to 2802
A1933
SR	  RMB	    1			;status register
THR					;transmit holding register (W)
IR	  RMB	    1			;interrupt register (R)
RHR					;receiver holding register (R)
AR	  RMB	    1			;address register (W)
CR3	  RMB	    1			;control register
CR2	  RMB	    1
CR1	  RMB	    1

